<template>
    <div class="container">
        <h1 class="text-center">{{title}}</h1>
        <div class="row">
            <div class="col-md-12">
                <app-address-list
                        :addresses="addresses"
                        v-on:onDeleteAddress="deleteAddress($event)"
                ></app-address-list>
                <app-new-address v-on:onCreateAddress="createAddress($event)"
                ></app-new-address>
            </div>
        </div>
    </div>
</template>

<script>

    import AddressList from './components/address-list.vue'
    import NewAddress from './components/new-address.vue'
    import AddressService from './services/AddressService.js'

    let addressService = new AddressService();

    export default {
        data () {
            return {
                title: 'Fictional Address List: Vue.js',
                addresses: []
            }
        },
        created: function ()
        {
            this.getAddresses();
        },
        methods: {
            getAddresses() {
                addressService.getAddresses()
                    .then(
                        response =>
                        {
                            this.addresses = response.data.addresses;
                        }
                    )
                    .catch(
                        error => console.log(error)
                    );
            },
            deleteAddress(address){
                addressService.deleteAddress(address)
                    .then(
                        response =>
                        {
                            this.getAddresses();
                        }
                    )
                    .catch(
                        error => console.log(error)
                    );
            },
            createAddress(address){
                addressService.createAddress(address)
                    .then(
                        response =>
                        {
                            this.getAddresses();
                        }
                    )
                    .catch(
                        error => console.log(error)
                    );
            }
        },
        components: {
            'app-address-list': AddressList,
            'app-new-address': NewAddress
        }
    }
</script>

<style>

</style>
